<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));  
$ih = Loader::helper('image'); 

$numOfCols= intval($controller->columns) ? intval($controller->columns):3;
$maxThumbWidth=(intval($controller->maxThumbWidth))?intval($controller->maxThumbWidth):500;
$maxThumbHeight=(intval($controller->maxThumbHeight))?intval($controller->maxThumbHeight):500;

global $c;

$targetPage = Page::getById(intval($controller->searchTargetCID)); 
if( !is_object($targetPage) || !$targetPage->getCollectionId() ) $targetPage = $c;

if(intval($controller->detailTargetCID)){
	$linkTargetPage = Page::getById($controller->detailTargetCID);
	if(is_object($linkTargetPage)){
		$linkTargetUrl=$linkTargetPage->getCollectionPath();	
		if(!strstr($linkTargetUrl,'?')) $linkTargetUrl.='?';
	}
}


$shownAttrs = explode( ',' , $controller->shownAttributes );
$searchAttrs = explode( ',' , $controller->searchableAttributes );
$labelAttrs = explode( ',' , $controller->shownLabels );
$defaultDetails=$controller->getDefaultDetails(); 
$defaultSearchDetails=$controller->getDefaultSearchableAttrs(); 

?> 
    
<div id="tonyImageSearch<?php echo intval($bID)?>" class="tonyImageSearch"> 
	
	<?php  if( $controller->mode!='results' ){ ?>
	
		<div class="imageSearchBox">
			<form method="get" action="<?php echo View::url( $targetPage->getCollectionPath() ) ?>"> 
			
				<input name="sortBy" type="hidden" value="<?php echo htmlentities( $sortBy, ENT_QUOTES, 'UTF-8') ?>" />
			
				<?php  if(strlen(trim($controller->searchTitle))){ ?>
					<h3 class="noTopSpace" style="margin-bottom:12px;"><?php echo  $controller->searchTitle ?></h3>
				<?php  } ?>
			
			
				<?php  /*
				<div class="fieldPair">
					<label><?php echo  t('Keywords:') ?></label> 
					<?php 
					$keywords=($_GET['keywords'])?$_GET['keywords']:$_GET['tag'];
					?>
					<input name="keywords" type="text" class="txtField" value="<?php echo htmlentities($keywords)?>" />
				</div>
				*/ ?>
				
				<?php  foreach( $searchAttrs as $attrHandle ){
					
						if( array_key_exists( $attrHandle, $defaultSearchDetails) ){
							$keyName=$defaultSearchDetails[$attrHandle];
							$fieldHTML='';
							switch ( $attrHandle ){
								case 'FID':  
									$displayedFID = intval( $_GET['fID'] ) ? intval( $_GET['fID'] )  : '';
									$fieldHTML = '<input name="fID" type="text" class="ccm-input-text" value="' . $displayedFID . '" size="6" />';
									break; 								
								case 'Keywords': 	 
									$keywords = (!$_REQUEST['keywords'] && !in_array( 'Tags', $searchAttrs)) ? $_REQUEST['tag'] : $_REQUEST['keywords'];
									$fieldHTML = '<input name="keywords" type="text" class="ccm-input-text" value="' . htmlentities( $keywords, ENT_QUOTES, 'UTF-8') . '" />'; 
									break; 
								case 'Tags':  
									$fieldHTML = '<input name="tag" type="text" class="ccm-input-text" value="' . htmlentities( $_GET['tag'], ENT_QUOTES, 'UTF-8') . '" />';
									break; 
								case 'Date':
									$fieldHTML = $form->text('date_from', array('style' => 'width: 86px')); 
									$fieldHTML .=  ' '.t('to').' ';
									$fieldHTML .=  $form->text('date_to', array('style' => 'width: 86px'));
									break; 
								case 'File': 	
									$fieldHTML = '<input name="filename" type="text" class="ccm-input-text" value="' . htmlentities( $_GET['filename'], ENT_QUOTES, 'UTF-8') . '" />'; 
									break; 
								case 'FileSize': 	
									
									break; 	
								case 'Sets': 	
									$setIdsArray = explode( ',', $controller->setIds ); 
									$searchableSets=array();
									foreach( $setIdsArray as $setId ){
										$fs = FileSet::getById(intval($setId)); 
										if( !is_object($fs) || !$fs->getFileSetID() ) continue; 
										$searchableSets[$fs->getFileSetName()] = $fs;
									}  
									if( !count($searchableSets) ){
										$searchableSets = $controller->getDefaultSearchableFileSets(); 
									}
									ksort($searchableSets);
									foreach($searchableSets as $fs){
										$checked=(in_array($fs->getFileSetID(),$searchedSetIds))?'checked="checked"':'';
										$fieldHTML .= '<div><input name="sets[]" type="checkbox" value="'.$fs->getFileSetID().'" '.$checked.' />'.$fs->getFileSetName().'</div> '; 
									}
									break; 										
								case 'FileType':
									$fileTypeIdsArray = ( !strlen($controller->fileTypeIds) )?'':explode( ',', $controller->fileTypeIds); 
									if(!is_array($fileTypeIdsArray)) $fileTypeIdsArray=array();
									$fTypes=array( '0'=>'--' );
									$typesArray = FileList::getTypeList();
									$types = array();
									foreach($typesArray as $value){ 
										if( !intval($value) || (count($fileTypeIdsArray) && !in_array($value,$fileTypeIdsArray)) ) continue; 
										$types[$value] = FileType::getGenericTypeText($value);
									}
									foreach($types as $key=>$val) $fTypes[$key]=$val; 
									$fieldHTML = $form->select('fType', $fTypes );
									break;
							}  
						}else{ 
							/* 
							if( !is_object($attrKey) ) continue; 
							$keyName = $attrKey->getAttributeKeyName();
							$attrVal = $fv->getAttribute( $attrKey->getAttributeKeyHandle() );
							*/ 
							$attrKey = FileAttributeKey::getByHandle( $attrHandle );
							if( !is_object($attrKey) ) continue; 
							$keyName = $attrKey->getAttributeKeyName(); 
							$fieldHTML = $attrKey->render('form', false, true);
							?> 
					<?php  	} ?>
					
					<div class="fieldPair">
						<label><?php echo  $keyName . t(': '); ?></label>
						<div class="fieldCol"><?php echo  $fieldHTML ?></div>
						<div class="spacer"></div>
					</div>
					
				<?php  } ?> 
				
				<div class="searchButtonWrap">
					<input name="Search" type="submit" value="Search &raquo;" />
				</div>
				
				<div class="spacer"></div>				
				
			</form> 
			
		</div>
	
	<?php  } ?>
	
	
	
	
	<?php  if( $controller->mode!='search' ){ ?>
	
	
		<?php  if( !count($files) ){ ?>
			<div style="margin:32px; text-align:center">
				<?php echo t('No results match your query.') ?><br />  <br />
				<?php echo t('Please try another search.') ?>
			</div>
		<?php  }else{ ?>
		
			<?php  if($controller->showSortBy){ ?>
			
				<div class="imageSearch_orderByWrap"> 
					<form id="imageSearchSortingForm<?php echo intval($bID) ?>" method="get" action="<?php echo $page_base ?>"> 
						
						<input name="resortQStr" type="hidden" value="<?php echo htmlentities( serialize($_GET), ENT_QUOTES, 'UTF-8') ?>" />
						
						<?php echo  t('Sort By: ') ?> 
						<select name="sortBy" onchange="$('#imageSearchSortingForm<?php echo intval($bID) ?>').submit()" >  
							<?php  
							$sortableOpts = $controller->getDefaultSortableOpts();
							$sortableByArray = explode( ',', $controller->sortByOpts ); 
							foreach( $sortableByArray as $sortableOpt ){ 
								if( !$sortableOpt ) continue;
								 $optTitle =  $sortableOpt;
								if( array_key_exists($sortableOpt,$sortableOpts) ) $optTitle = $sortableOpts[$sortableOpt];
								elseif( strstr($sortableOpt,'fak_') ){
									$ak =  FileAttributeKey::get( intval(str_replace('fak_','',$sortableOpt)) );  
									if( !is_object($ak) ) continue; 
									$optTitle = $ak->getAttributeKeyName(); 
								}
								?> 
								<option value="<?php echo $sortableOpt ?>" <?php echo ($sortBy==$sortableOpt)?'selected="selected"':'' ?>><?php echo $optTitle ?></option>
							<?php  } ?>
						</select>
						
						<?php  if($controller->mode=='results'){ ?>
							<noscript>
							<input type="submit" name="submit" value="submit"  />
							</noscript>
						<?php  } ?> 
					</form>
				</div>
			
			<?php  } ?>
			
		
			<h3>
				<?php 
				$searchTerm=(strlen($_GET['tag']))?$_GET['tag']:$_GET['keywords'];
				?>
				<?php echo $filesCount?> <?php echo  ($filesCount!=1)?t('results'):t('result')?> 
				<?php  if( (strlen($_GET['tag']) && in_array('Tags',$searchAttrs) ) || (strlen($_GET['keywords']) && in_array('Keywords',$searchAttrs) )){ ?> 
					<?php echo  t('match the') ?> <?php echo (strlen($_GET['tag']))?t('tag'):t('keywords') ?> "<?php echo htmlentities( $searchTerm, ENT_QUOTES, 'UTF-8')?>"
				<?php  }else{ ?> 
					<?php echo  t('found') ?>
				<?php  } ?>
			</h3>
			
			<div class="spacer"></div>
		
			<div class="imageSearchResults"> 
					<?php  
					$resultNum=0; 
					//loop through all files
					foreach($files as $file){  
						if($resultNum>0 && $resultNum%$numOfCols==0) echo '<div class="spacer"></div>';
						$resultNum++; 
						$fv = $file->getApprovedVersion(); 
						$imageThumb = $ih->getThumbnail( $file, $maxThumbWidth, $maxThumbHeight );
						
						$imageLinkTargetUrl = $controller->getImageLink($fv,$linkTargetUrl);  
						
						$positionClass='';
						if(($resultNum-1)%$numOfCols==0) $positionClass='first';
						elseif($resultNum%$numOfCols==0) $positionClass='last';
						?> 				
							<div id="photo-list-item<?php echo $resultNum ?>" class="photo-list-item <?php echo ($resultNum%$numOfCols==0)?'lastCol':''?>" style="width:<?php echo round((100/$numOfCols)-.2) ?>%"> 
								<div class="photo-list-item-inner <?php echo $positionClass ?>">
							
								<?php  /*
								<div id="imgWrap<?php echo intval($file->getFileID()) ?>" class="imgWrap <?php echo ( ($resultNum-1)==$selectedImgNum )?'selected':''?>">
								<?php  if($imageLinkTargetUrl){ ?><a class="imageSearchLink" href="<?php echo $imageLinkTargetUrl ?>" title="<?php echo htmlentities($fv->getTitle())?>" alt="<?php echo htmlentities($fv->getTitle())?>"
									><?php  } ?><img class="matted" src="<?php echo $imageThumb->src ?>" 
								/><?php  if($imageLinkTargetUrl){ ?></a><?php  } ?> 
								</div>
								*/ ?> 
								
								<?php  foreach( $shownAttrs as $attrHandle ){
									
									if( array_key_exists( $attrHandle, $defaultDetails) ){
										$keyName=$defaultDetails[$attrHandle];
										switch ( $attrHandle ){
											case 'Title': 	
												$attrVal = '<div class="imageSearch_title">'.$fv->getTitle().'</div>'; 
												if(strlen($titleWeight) && $titleWeight!='Bold')
													$attrVal = '<'.$titleWeight.'>'.$attrVal.'</'.$titleWeight.'>';
												if($imageLinkTargetUrl){
													$attrVal = '<a class="imageSearchLink" href="'.$imageLinkTargetUrl.'" title="'.htmlentities($fv->getTitle()).'" alt="'.htmlentities($fv->getTitle()).'" >'. 
																$attrVal.'</a>';
												}
												break; 
											case 'Description': 	
												$attrVal = $fv->getDescription();
												break; 
											case 'Tags': 	 
												$tags = $fv->getTagsList();
												$notFirstTag=0;
												$attrVal='';
												if(intval($tagsTargetCID)){
													$tagTarget=Page::getByid($tagsTargetCID);  
													$nh = Loader::helper('navigation');   
													if( is_object($tagTarget) ){
														$tagTargetURL = $nh->getLinkToCollection($tagTarget); 
														if( !strstr( $tagTargetURL,'?') ) $tagTargetURL.='?';
														if(!strlen($tags_qStrVar)) $tags_qStrVar = 'tag';
														$tagTargetURL.='&'.$tags_qStrVar.'=';
													}
												}
												foreach($tags as $tag){ 
													if($notFirstTag) $attrVal .= ', ';
													if( strlen($tagTargetURL) )  $attrVal .= '<a href="'.$tagTargetURL.urlencode($tag).'">'.$tag.'</a>';  
													else  $attrVal .= $tag;  
													$notFirstTag=1;
												} 
												break; 
											case 'Date': 	
												//$attrVal = date('M d, Y g:ia', strtotime($file->getDateAdded()));
												$attrVal = $file->getDateAdded();
												$attrVal .= date('M d, Y', strtotime($file->getDateAdded()));
												break; 
											case 'File': 	
												$attrVal = $fv->getFileName();
												break; 
											case 'FileSize': 	
												$attrVal = $fv->getSize();
												break; 													
											case 'Image': 
												$ih = Loader::helper('image');
												$mw = $maxThumbWidth;
												$mh = $maxThumbHeight;
												$thumb = $ih->getThumbnail($file, $mw, $mh); 
												if($thumb->src){ 
													ob_start();
													$ih->outputThumbnail($file, $mw, $mh);
													$attrVal=ob_get_contents();
													ob_end_clean();
												}else{ 
													$ft = FileTypeList::getType( $fv->getFileName() ); 
													$attrVal=$ft->getThumbnail(1, true);
												} 
												if( strlen(trim($imageLinkTargetUrl)) ){
													$attrVal = '<a class="imageSearchLink" href="'.$imageLinkTargetUrl.'" title="'.htmlentities($fv->getTitle()).'" alt="'.htmlentities($fv->getTitle()).'" >'.
															 	$attrVal.'</a>'; 
													//$attrVal = '<a href="'.str_replace('"','',trim($imgLinkURL)).'">'.$attrVal.'</a>';
												}
												if( !in_array( $attrHandle,$labelAttrs) )
													$attrVal='<div class="imageSearch_noLabelImage">'.$attrVal.'</div>';
												break;  
											case 'Download':
												if( in_array( $attrHandle,$labelAttrs) ) 
													 $attrVal=$fv->getFileName();
												else $attrVal='Download';
												$attrVal='<a href="'.$fv->getDownloadURL().'">'.$attrVal.'</a>';
												$keyName='Download';
												break; 						
										} 
									}else{ 
										$attrKey = FileAttributeKey::getByHandle( $attrHandle );
										if( !is_object($attrKey) ) continue; 
										$keyName = $attrKey->getAttributeKeyName();
										$attrVal = $fv->getAttribute( $attrKey->getAttributeKeyHandle() );
									}
									
									if( $hideEmptyAttrs && !strlen($attrVal) ) continue;
									?> 
									
									<div class="imageSearch_row imageSearch_detail_<?php echo $attrHandle ?>">
										<?php  if( in_array( $attrHandle,$labelAttrs) ){ ?> 
											<label><?php echo  $keyName ?></label> 
										<?php  } ?> 
										<div class="imageSearch_rowVal <?php echo (in_array( $attrHandle,$labelAttrs))?'':'imageSearch_fullRow'?>"><?php echo  $attrVal ?></div>
										<div class="spacer"></div> 
									</div>
									
								<?php  } ?>	
								
								</div>							
							</div> 		
								
					<?php  }
					
					/* 
					if(intval($resultNum%$numOfCols)) for($i=0;$i<($numOfCols-($resultNum%$numOfCols));$i++){
						echo '<td>&nbsp;</td>';
					} */ 
					?>  
			</div>
			<div class="spacer"></div>
		<?php  } ?>	
		
	
		<?php  if($paginator && strlen($paginator->getPages())>0){ ?>	
			<div class="pagination">	
				 <span class="pageRight"><?php  echo $paginator->getNext(t('Next &raquo;'))?></span>
				 <span class="pageLeft"><?php  echo $paginator->getPrevious(t('&laquo; Previous'))?></span>
				 <?php  echo $paginator->getPages()?>				 
			</div>	
		<?php  } ?>		
	
	
	<?php  } ?> 
	
</div>