
//xml-swf chart variables 
var ParticleTrafficRequiredMajorVersion = 9;
var statsDefaultTimeFrame = 'week';
var statsDefaultDisplayMode = 'graph';
ParticleTraffic_URL_DIR="<?php echo ParticleTraffic_URL_DIR?>"; 

try{

var ParticleTraffic={
	timeframe:"",
	visitDisplayMode:"",
	xml_source:'<?php echo ParticleTraffic_SERVICES_URL?>?mode=graph_xml&',
	bID:<?php echo intval($siteIdNumber)?>,
	init:function(){
		//if( !this.$('visitGraphFlash') ) return false;
		try{
			this.timeframe=statsDefaultTimeFrame;
			this.visitDisplayMode=statsDefaultDisplayMode; 
			var flashHeight=350;
			if(this.majorFlashVersion()>=ParticleTrafficRequiredMajorVersion){
				this.flashFound=1; 
				var flashvars={
					chart_id:'visitGraphFlash',
					library_path:ParticleTraffic_URL_DIR+'xml_swf_charts/charts_library',
					xml_source:encodeURIComponent(this.xml_source+'timeframe='+statsDefaultTimeFrame+'&bID='+parseInt(ParticleTraffic.bID))
				}
				var flashparams={
					bgcolor:'#fafafa', 
					codebase:'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,45,0',
					//scale:'noscale', 
					wmode:'opaque', 
					movie:'charts',
					allowScriptAccess:'sameDomain',
					id:'visitGraphFlash',
					name:'visitGraphFlash', 
					align:'middle', 
                    valign:'top', 
                    salign:'t',
					pluginspage:'http://www.macromedia.com/go/getflashplayer' 		
				}		
				swfobject.embedSWF(ParticleTraffic_URL_DIR+'xml_swf_charts/charts.swf', "visitGraphFlash", "100%", flashHeight, "9.0.0", ParticleTraffic_URL_DIR+"/js/swfobject/expressInstall.swf",flashvars,flashparams );
				
				//turn off clickability
				//this.mask=ParticleTraffic.$('visitGraphMask');
				//this.mask.style.height=flashHeight+'px';
			}		

		}catch(e){alert(e.message+' book_stats.js init')}
	}, 
	popularityDataView:function(panel,a){ 
		var panels=['Day','Week','Year'];
		this.swapPanel('visitData',panels,panel,a);
		this.timeframe=panel.toLowerCase();
		this.updateGraphCheck();
	},	
	popularityView:function(panel,a){ 
		var panels=['Graph','Table'];
		this.swapPanel('visitDisplay',panels,panel,a);
		this.visitDisplayMode=panel.toLowerCase();
		this.updateGraphCheck();
	},	
	updateGraphCheck:function(){
		if(this.visitDisplayMode=='graph')
			this.changeGraphXML();	
	},
	pgsView:function(panel,a){ 
		var panels=['Top','Recent'];
		this.swapPanel('pagesData',panels,panel,a);
	},
	discoveryView:function(panel,a){ 
		var panels=['Referrers','Searches'];
		this.swapPanel('discovery',panels,panel,a);
	},	
	discoverySort:function(panel,a){ 
		var el,i, panels=['SearchesRecent','SearchesTop','ReferrersRecent','ReferrersTop'];
		this.removeClass(this.$('discoveryDataTopLink'),'selected');	
		this.removeClass(this.$('discoveryDataRecentLink'),'selected');
		this.addClass(a,'selected')
		for(i=0;i<panels.length;i++){
			el=this.$('discoveryData'+panels[i]+'Wrap');
			if(panels[i].indexOf(panel)>0){
				this.removeClass(el,'none');
			}else{
				this.addClass(el,'none');				
			}
		}
	},	
	usrAgentView:function(panel,a){ 
		var panels=['Platforms','Browsers','Screens','Flash'];
		this.swapPanel('userAgentData',panels,panel,a);	
	},
	swapPanel:function(prefix,panels,panel,a){
		var el,i;
		this.addClass(a,'selected')
		for(i=0;i<panels.length;i++){
			el=this.$(prefix+panels[i]+'Wrap');
			if(!el) continue; 
			if(panels[i]==panel){ 			
				this.removeClass(el,'none');
			}else{
				this.addClass(el,'none');
				a=this.$(prefix+panels[i]+'Link');
				this.removeClass(a,'selected');				
			}
		}	
	},
	browserVersions:function(r,el){
		this.toggleArrow(el);
		this.toggleClass(this.$('versionsNumbersWrap'+r),'none');
		this.toggleClass(this.$('versionsUsageWrap'+r),'none');
	},
	showPathDetails:function(r,el){
		this.toggleArrow(el);
		this.toggleClass(this.$('visitPathDetails'+r),'none');
		this.toggleClass(this.$('visitPathStats'+r),'none');
	},	
	toggleArrow:function(el){   
        var arrow=$(el).find('.arrow')
        arrow.toggleClass('arrowRight');
        arrow.toggleClass('arrowDown');
	},
	renderCount:0,
	changeGraphXML:function(){ 
   	  if(!this.flashFound) return;
	  if(this.changingGraphs) return;
      // the update url to download the xml update from
      //var url = "/stats/graph_xml/?timeframe="+this.timeframe; 
	  var url = this.xml_source+'timeframe='+this.timeframe+'&bID='+parseInt(this.bID); 
      // show a spinning wheel while downloading the update
      spinning_wheel = true;  
      // number of seconds to wait before a download times out
      timeout = 30;  
      // number of times to try downloading before displaying an error
      retry = 2;  
      // the update mode (see the update function)
      mode = "reset"; 
	  try{
		if(navigator.appName.indexOf("Microsoft") != -1) {
			var flashObj = window.visitGraphFlash;
		}else {
			var flashObj = window.document.visitGraphFlash;
		}
		if(typeof(flashObj)=='undefined' || typeof(flashObj.Update_URL)!="function") 
			throw 'flash object not found'; 
		flashObj.Update_URL( url, spinning_wheel, timeout, retry, mode ); 
		this.changingGraphs=1;
		setTimeout('ParticleTraffic.changingGraphs=0;',500);
	  }catch(e){ 
	  	setTimeout('ParticleTraffic.changeGraphXML()',200);
	  }
	},	
	hasClass:function(el,c){ return (!el.className || el.className.indexOf(c)>-1)?1:0 },
	addClass:function(el,newClass){
		if(!el) return;
		elClasses=(el.className)?el.className.split(' '):[];
		for(i=0;i<elClasses.length;i++)
			if(newClass==elClasses[i]) return;
		el.className=el.className+' '+newClass;
	},
	removeClass:function(el,rmvClass){  
		if(!el || !el.className) return; 
		var elClasses=el.className.split(' ');
		for(i=0;i<elClasses.length;i++)
			if(rmvClass==elClasses[i]){
				elClasses[i]='';
			}
		el.className=elClasses.join(' ');
	},
	toggleClass:function(el,c){
		if( this.hasClass(el,c) )
			 this.removeClass(el,c);
		else this.addClass(el,c);
	},
	$:function(id){ 
		var elements = new Array();
		for (var i = 0; i < arguments.length; i++) {
			var element = arguments[i];
			if (typeof element == 'string')
				element = document.getElementById(element);
			if (arguments.length == 1)
				return element;
			elements.push(element);
		}
		return elements;	
	},
	<?php  include(ParticleTraffic_PATH.'js/ParticleTraffic.common_script.php') ?>
}

}catch(e){alert(e.message+' :: An error from ParticleTraffic.display.js page load')}