<?php  defined('C5_EXECUTE') or die(_("Access Denied.")); ?>

<style>
#statsTimelinks a.selected { font-weight:bold; }
</style>

<script>

//xml-swf chart variables 
var ParticleTrafficRequiredMajorVersion = 9;
var statsDefaultTimeFrame = 'week';
var statsDefaultDisplayMode = 'graph';
ParticleTraffic_URL_DIR="<?php echo ParticleTraffic_URL_DIR?>";

var TonyStatsModule={
	
	timeframe:"", 
	xml_source:'<?php echo ParticleTraffic_SERVICES_URL?>?mode=graph_xml&',
	bID:0,
	init:function(){
		//if( !this.$('visitGraphFlash') ) return false;
		try{
			this.timeframe='week';  
			var flashHeight=270;
			if(this.majorFlashVersion()>=ParticleTrafficRequiredMajorVersion){
				this.flashFound=1;
				var flashvars={
					chart_id:'visitGraphFlash',
					library_path:ParticleTraffic_URL_DIR+'xml_swf_charts/charts_library',
					xml_source:encodeURIComponent(this.xml_source+'timeframe='+this.timeframe+'&bID='+parseInt(TonyStatsModule.bID))
				}
				var flashparams={
					bgcolor:'#fafafa', 
					codebase:'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,45,0',
					//scale:'noscale', 
					wmode:'opaque', 
					movie:'charts',
					allowScriptAccess:'sameDomain',
					id:'visitGraphFlash',
					name:'visitGraphFlash', 
					align:'middle', 
					salign:'t', 
					pluginspage:'http://www.macromedia.com/go/getflashplayer' 		
				}		
				swfobject.embedSWF(ParticleTraffic_URL_DIR+'xml_swf_charts/charts.swf', "visitGraphFlash", "100%", flashHeight, "9.0.0", ParticleTraffic_URL_DIR+"/js/swfobject/expressInstall.swf",flashvars,flashparams );
				
				//turn off clickability
				//this.mask=ParticleTraffic.$('visitGraphMask');
				//this.mask.style.height=flashHeight+'px';
			}		

		}catch(e){alert(e.message+' book_stats.js init')}
	},
	
	 
	popularityDataView:function(panel,a){ 
		var panels=['Day','Week','Year']; 
		this.timeframe=panel.toLowerCase();
		$('#statsTimelinks a').removeClass('selected'); 
		$(a).addClass('selected');
		this.changeGraphXML();
	},
	
	renderCount:0,
	changeGraphXML:function(){ 
   	  if(!this.flashFound) return;
	  if(this.changingGraphs) return;
      // the update url to download the xml update from
      //var url = "/stats/graph_xml/?timeframe="+this.timeframe; 
	  var url = this.xml_source+'timeframe='+this.timeframe+'&bID='+parseInt(TonyStatsModule.bID); 
      // show a spinning wheel while downloading the update
      spinning_wheel = true;  
      // number of seconds to wait before a download times out
      timeout = 30;  
      // number of times to try downloading before displaying an error
      retry = 2;  
      // the update mode (see the update function)
      mode = "reset"; 
	  try{
		if(navigator.appName.indexOf("Microsoft") != -1) {
			var flashObj = window.visitGraphFlash;
		}else {
			var flashObj = window.document.visitGraphFlash;
		}
		if(typeof(flashObj)=='undefined' || typeof(flashObj.Update_URL)!="function") 
			throw 'flash object not found'; 
		flashObj.Update_URL( url, spinning_wheel, timeout, retry, mode ); 
		this.changingGraphs=1;
		setTimeout('TonyStatsModule.changingGraphs=0;',500);
	  }catch(e){ 
	  	setTimeout('TonyStatsModule.changeGraphXML()',200);
	  }
	},
	
	<?php  include(ParticleTraffic_PATH.'js/ParticleTraffic.common_script.php') ?>
	
}

$(function(){ TonyStatsModule.init(); });

</script>

<div style="width:100%;">
    
    <div style="float:right; ">
        <a href="<?php echo View::url('dashboard/stats') ?>"><?php echo t('More Statistics &raquo;') ?></a>
    </div>
    
    <div id="statsTimelinks">
        <a href="#" id="visitDataDayLink" onclick="TonyStatsModule.popularityDataView('Day',this); return false;"><?php echo t('Day') ?></a>&nbsp; 
        <a href="#" id="visitDataWeekLink" class="selected" onclick="TonyStatsModule.popularityDataView('Week',this); return false;"><?php echo t('Week') ?></a>&nbsp; 
        <a href="#" id="visitDataYearLink" class="" onclick="TonyStatsModule.popularityDataView('Year',this); return false;"><?php echo t('Year') ?></a>
    </div>
    
    <div style="margin:auto; width:350px">
    <div id="visitGraphFlash">			
        <div style="padding:8px; text-align:center" class="faint small">
            This graph requires <a href="http://www.adobe.com/go/getflashplayer">Adobe Flash</a>.
        </div>
    </div>
    </div>
</div>